import 'package:flutter/widgets.dart';
import 'package:oc_front/core/services/api_service.dart';
import 'package:oc_front/core/services/specialized_services/abstract_service.dart';
import 'package:oc_front/models/response.dart';
import 'package:oc_front/models/workflow.dart';

class CheckService extends AbstractService<Check> {
  @override
  late final APIService<Check> service;

  @override
  String subPath = "/check/";

  CheckService() {
    service = APIService<Check>(
        baseURL: super
            .conf
            .get('CHECK_HOST', defaultValue: 'http://localhost:8080/check'));
  }

  Future<APIResponse<Check>> search(
      BuildContext? context, List<String> words, Map<String, dynamic> params) {
    return service.get("$subPath${words.join("/")}", true, context);
  }

  @override
  Future<APIResponse<RawData>> all(BuildContext? context) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<Check>> get(BuildContext? context, String id) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<Check>> post(BuildContext? context,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<Check>> put(BuildContext? context, String id,
      Map<String, dynamic> body, Map<String, String> params) {
    throw UnimplementedError();
  }

  @override
  Future<APIResponse<Check>> delete(
      BuildContext? context, String id, Map<String, String> params) {
    throw UnimplementedError();
  }
}
