
import 'package:flutter/material.dart';
import 'package:flutter_flow_chart/flutter_flow_chart.dart';
import 'package:oc_front/models/workflow.dart';
import 'package:oc_front/widgets/inputs/sub_text_input.dart';

class SubKeysMapFormsWidget extends StatefulWidget {
  bool readOnly = false;
  FlowData item;
  Dashboard dash; 
  String varKey = "";
  bool empty = false;
  bool isInput = true;
  String elementID = "";
  String categoryKey = "";
  List<GraphItem> graphItems = [];
  SubKeysMapFormsWidget({ super.key, required this.dash, required this.isInput, this.readOnly = false,
    this.empty = false, required this.item, required this.elementID, required this.graphItems,
    required this.categoryKey, required this.varKey });
  @override SubKeysMapFormsWidgetState createState() => SubKeysMapFormsWidgetState();
}
class SubKeysMapFormsWidgetState extends State<SubKeysMapFormsWidget> {

  @override Widget build(BuildContext context) {
    List<Widget> children = [];

    bool save = false;
    for (var graphItem in widget.graphItems) {
      int count = 0;
      var el = graphItem.getElement();
      if (el == null || el.model == null) { continue; }
      for ( var r in el.model!.refs.keys) {
        var env = widget.item.getVariable(["container", "env"], widget.item.serialize());
        if (env == null || env is Map<String, dynamic>) { continue; }
        var n = "${el.topic.toUpperCase()}_${el.getName().toUpperCase().replaceAll(" ", "_")}_${r.toUpperCase()}_$count";
        if (env[n] == null) {
          save = true;
        }
        env[n]= "{{ ${ widget.isInput ? "in" : "out" }_${graphItem.id}_$r }}";
        widget.item.setVariable(["container", "env"], env, el.serialize());
        children.add( Padding(padding: const EdgeInsets.only(bottom: 10), 
          child: SubTextInputWidget(subkey: n, width: 180, empty: false, change: (value) {}, 
          initialValue: n, readOnly: true, noLabel: true)));
        count++;
      }
    }
    if (save) {
      widget.dash.saveDash(widget.dash.id);
    }
    if (children.isEmpty) {
      return Container();
    }
    return Column( children : [
      Container(width: 200, padding: const EdgeInsets.only(top: 10, bottom: 10),
        decoration: const BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey, width: 1)))),
      Padding( padding: const EdgeInsets.only(top: 10),
        child: Text("<${widget.isInput ? "INPUT ENV VARIABLE" : "OUTPUT ENV VARIABLE"}>", style: const TextStyle(fontSize: 13, fontWeight: FontWeight.bold), 
                    textAlign: TextAlign.center)),
      Column( children: children),
    ]); 
  }
}