
import 'package:flutter/material.dart';
import 'package:flutter_flow_chart/flutter_flow_chart.dart';
import 'package:oc_front/widgets/inputs/sub_text_input.dart';

class MapForm {
  String key = "";
  String value = "";
  MapForm({ required this.key, required this.value });
}

class SubMapFormsWidget extends StatefulWidget {
  bool readOnly;
  String categoryKey = "";
  String varKey = "";
  String elementID = "";
  FlowData item;
  Dashboard dash; 
  bool empty = false;
  List<MapForm> forms = [];
  SubMapFormsWidget ({ super.key, required this.dash, this.readOnly = false,
    this.empty = false, required this.item, required this.elementID,
    required this.categoryKey, required this.varKey });
  @override SubMapFormsWidgetState createState() => SubMapFormsWidgetState();
}
class SubMapFormsWidgetState extends State<SubMapFormsWidget> {

  Map<String, dynamic> toMap() {
    Map<String, dynamic> m = {};
    for (var form in widget.forms) {
      m[form.key] = form.value;
    }
    return m;
  }

  @override Widget build(BuildContext context) {
    Map<String, dynamic>? m = widget.item.getVariable([widget.categoryKey, widget.varKey], widget.item.serialize());
    var l = [widget.categoryKey, widget.varKey];
    List<Widget> children = [];
    List<String> empty = [];
    widget.forms = [];
    var i = 0;
    for (var key in (m?.keys.toList() ?? empty)) {
      if (((m![key] as String?)?.contains('{{') ?? false)) {
        continue;
      }
      widget.forms.add(MapForm(key: key, value: m[key]));
      children.add(Row( children: [
        SubTextInputWidget(subkey: "key", readOnly: widget.readOnly,
          initialValue: key, width: 77.5, empty: widget.empty, 
          change: (value) { 
            setState(() {
              widget.forms[i].key = value;
              Future.delayed(const Duration(seconds: 2), () {
                widget.dash.saveDash(widget.dash.id);
            });
            var el = widget.dash.getElement(widget.elementID);
            widget.item = widget.item.deserialize(widget.item.setVariable(l, toMap(), widget.item.serialize())) as dynamic;
            el!.element = widget.item as dynamic;
          });
        }),
        const Padding(padding: EdgeInsets.only(left: 5, right: 5, top: 15), child: Text("=", textAlign: TextAlign.center,)),
        SubTextInputWidget(subkey: "value", initialValue: widget.forms[i].value, width: 77.5, empty: widget.empty, 
          readOnly: widget.readOnly, change: (value) { 
            Future.delayed(const Duration(seconds: 2), () {
                widget.dash.saveDash(widget.dash.id);
            });
            widget.forms[i].value = value;
            var el = widget.dash.getElement(widget.elementID);
            widget.item = widget.item.deserialize(
              widget.item.setVariable(l, toMap(), widget.item.serialize())) as dynamic;
            el!.element = widget.item as dynamic;
        }),     
      ]));
      i++;
    }
    return Column( children : [
      Container(width: 200, padding: const EdgeInsets.only(top: 10),
        decoration: const BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey, width: 1))),),
      widget.readOnly ? Container() : Row( children: [
              InkWell( onTap: () {
                  widget.forms.add(MapForm(key: "", value: ""));
                  var el = widget.dash.getElement(widget.elementID);
                  widget.item = widget.item.deserialize(
                    widget.item.setVariable(l, toMap(), widget.item.serialize())) as dynamic;
                  el!.element = widget.item as dynamic;
                  setState(() {});
                }, child: Container( margin: const EdgeInsets.only(top: 10),
                    decoration: BoxDecoration(borderRadius: BorderRadius.circular(5), border: Border.all(color: Colors.grey, width: 1)),
                    width: 125, height: 30,
                    child: Row( mainAxisAlignment: MainAxisAlignment.center,
                      children: [ const Padding( padding: EdgeInsets.only(right: 5), child: Icon(Icons.add)), Text("add ${widget.varKey} vars")]),
                  ),  
              ),
              InkWell( onTap: () {
                      if (widget.forms.isEmpty) { return;}
                      widget.forms.sublist(0, widget.forms.length - 1);
                      widget.item = widget.item.deserialize(
                        widget.item.setVariable(l, toMap(), widget.item.serialize())) as dynamic;
                      var el = widget.dash.getElement(widget.elementID);
                      el!.element = widget.item as dynamic;
                      setState(() { widget.dash.saveDash(widget.dash.id); });
                    }, child:
                    Container( margin: const EdgeInsets.only(left: 5, top: 10),
                      decoration: BoxDecoration(borderRadius: BorderRadius.circular(5), border: Border.all(color: Colors.grey, width: 1)),
                      width: 45, height: 30,
                      child: const Row( mainAxisAlignment: MainAxisAlignment.center,
                        children: [ Icon( Icons.delete, color: Colors.black ) ]),
                    )
                  ), 
            ]),
      ...children
    ]); 
  }
}